/*
 *  Copyright (C) 2012 Khaldoon Ghanem
 *  See the file license.txt for copying permission.
 */
 
%{

    #include <stdlib.h>
    #include <string.h>
    #define YYSTYPE char*
    #include "y.tab.h"    
    void yyerror(char *);
    int fileno(FILE *stream); 
%}
%option outfile="lex.yy.c"
%%

[0-9]+\.[0-9]+i {			
                    yylval = (char*) malloc(sizeof(char)*yyleng);
                    for(int i=0;i<yyleng;i++)
                        yylval[i] = yytext[i];
                    yylval[yyleng-1] = '\0';
                    return FLOAT_I;
                }

[0-9]+\.[0-9]+  {
                    yylval = (char*) malloc(sizeof(char)*(yyleng+1));
                    for(int i=0;i<yyleng+1;i++)
                        yylval[i] = yytext[i];
                    return FLOAT;
                }
     
[0-9]+i         {
                    yylval = (char*) malloc(sizeof(char)*yyleng);
                    for(int i=0;i<yyleng;i++)
                        yylval[i] = yytext[i];
                    yylval[yyleng-1] = '\0';
                    return INTEGER_I;
                }  
            	            	
[0-9]+          {
                    yylval = (char*) malloc(sizeof(char)*(yyleng+1));
                    for(int i=0;i<yyleng+1;i++)
                        yylval[i] = yytext[i];
                    return INTEGER;
                }
            	
            	
i		{			
			yylval = (char*) malloc(sizeof(char)*2);
			yylval[0] = '1';
			yylval[1] = '\0';			
			return INTEGER_I;
            	}            	
            	          	

Z|z     return VAR;

abs     return ABS;

arg     return ARG;

sin     return SIN;

cos     return COS;

tan     return TAN;

exp     return EXP;

log     return LOG;


[-+()\*/^\n]    return *yytext;

[ \t]       	; /* skip whitespace */

.               return INVALID;

%%

int yywrap(void)
{
    return 1;
}

